use indexed_view_online_test
go

-- create view
CREATE VIEW dbo.LINK_FULLURLS
WITH SCHEMABINDING
AS

SELECT 
  L.LinkId,
  CASE 
	WHEN L.IsExternal = 1 THEN L.URL
	ELSE C.BaseURL + L.URL
  END AS FullURL,
  CHECKSUM 
    ( 
      CASE 
	    WHEN L.IsExternal = 1 THEN L.URL
	    ELSE C.BaseURL + L.URL
      END
    ) AS FullURLChecksum
FROM dbo.LINKS L 
INNER JOIN dbo.CLIENTS C
  ON C.ClientId = L.ClientId
WHERE L.DateDeleted IS NULL;
GO -- 0 seconds

-- read CX into memory
DECLARE @Count BIGINT;
SELECT @Count = COUNT(*) 
FROM dbo.LINKS WITH ( NOLOCK, INDEX(1) ); 
GO -- 20 seconds online

CREATE UNIQUE CLUSTERED INDEX IX_LINK_FULLURLS
  ON dbo.LINK_FULLURLS ( LinkId )
GO -- 1 minute 50 seconds offline (warm cache)

CREATE NONCLUSTERED INDEX IX_LINK_FULLURLS_FullURLChecksum
  ON dbo.LINK_FULLURLS ( FullURLChecksum ) 
  INCLUDE ( FullURL )
  WITH ( ONLINE = ON );
GO -- about 2 minutes 30 seconds (but online)