CREATE TABLE dbo.CLIENTS
(
  ClientId INT IDENTITY NOT NULL
    CONSTRAINT PK_CLIENT PRIMARY KEY,
  ClientName NVARCHAR(50) NOT NULL,
  BaseURL NVARCHAR(256) NOT NULL,
);

CREATE TABLE dbo.LINKS
(
  Linkid INT IDENTITY NOT NULL
    CONSTRAINT PK_LINKS PRIMARY KEY,
  Name NVARCHAR(200) NOT NULL,
  [Description] NVARCHAR(2000) NOT NULL,
  IsExternal BIT NOT NULL,
  URL NVARCHAR(1000) NOT NULL,
  ClientId INT NOT NULL
    CONSTRAINT FK_LINKS_CLIENTS
	FOREIGN KEY REFERENCES CLIENTS(ClientId),
  DateDeleted DATETIME2 NULL
);
GO

-- add a 50000 clients
WITH
   L0 as (select 1 as C union all select 1)       --2 rows
  ,L1 as (select 1 as C from L0 as A, L0 as B)    --4 rows
  ,L2 as (select 1 as C from L1 as A, L1 as B)    --16 rows
  ,L3 as (select 1 as C from L2 as A, L2 as B)    --256 rows
  ,L4 as (select 1 as C from L3 as A, L3 as B)    --65536 rows  
INSERT TOP (50000) dbo.CLIENTS (ClientName, BaseURL)
SELECT CAST(NEWID() AS NVARCHAR(100)), 'http://' + CAST(NEWID() AS NVARCHAR(100)) + '.com/'
FROM L4;
GO


-- add 10,000,000 links
SET NOCOUNT ON

INSERT dbo.LINKS (Name, [Description], IsExternal, URL, ClientId, DateDeleted)
SELECT ClientName + CAST(NEWID() AS NVARCHAR(100)), 
       ClientName + CAST(NEWID() AS NVARCHAR(100)), 
	   CASE ClientId % 10
	     WHEN 1 THEN CAST(1 AS BIT)
		 ELSE CAST(0 AS BIT)
	   END,
       CASE ClientId % 10 
         WHEN 1 THEN 'http://' + CAST(NEWID() AS NVARCHAR(100)) + '.com/' + CAST(NEWID() AS NVARCHAR(100))
	     ELSE CAST(NEWID() AS NVARCHAR(100))
       END,
	   ClientId,
	   CASE ClientId % 3
	     WHEN 1 THEN SYSDATETIME()
		 ELSE NULL
	   END
FROM dbo.CLIENTS
GO 200 -- 6 minutes on my machine
